/*         .c                       freeware                   xhunga@tiscali.fr
*/

/* --------------------------------- INCLUDES ------------------------------- */
#include "xa_hfile.h"

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
double f(
double x)
{
 return(       3.0*x*x  - 2.0*x - 5.0);
}
char  feq[] = "3.0*x**2 - 2.0*x - 5.0";
/* -------------------------------------------------------------------------- */
double Df(
double x)
{
 return(       6.0*x - 2.0);
}
char Dfeq[] = "6.0*x - 2.0";
/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */

/* --------------------------------- MAIN ----------------------------------- */
int main(void)
{
double (*Pfunct)     (double x);
double (*PfunctDeriv)(double x);

double c = 1;
/*-------------------------------- PROGRAM ---------------------------------- */
 Pfunct      =  f;
 PfunctDeriv = Df;

 clrscrn();
 printf("  f : x-> %s\n\n",feq );
 printf(" Df : x-> %s\n\n",Dfeq);

 printf(" With c = %0.3lf, the equation of the tangent is :\n\n",c);
 printf("       Df(c) (x-c) + f(c) = ");
 eq_Tan(  c,
       (*Pfunct),
       (*PfunctDeriv)
       );
 printf("\n\n");
                         /* plot [xmin:xmax] [ymin:ymax] */
     gplt_Tan  (-4,      /* xmin */
                 4,      /* xmax */
                -6,      /* ymin */
                 6,      /* ymax */
                 c,
               feq,
         (*Pfunct),
         (*PfunctDeriv)
               );

 printf("\n\n To see the result in Gnuplot (gp373w32.exe) :\n\n");
 printf("     * open the file f_Df.plt with Gnuplot.\n");

 printf("\n Press return to continue");
 getchar();

 return 0;
}

