/*         .c                       freeware                   xhunga@tiscali.fr
*/

/* --------------------------------- INCLUDES ------------------------------- */
#include "xa_hfile.h"

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
double f(
double x)
{
 return(       exp(x));
}
char  feq[] = "exp(x)";
/* -------------------------------------------------------------------------- */
double Df(
double x)
{
 return(       exp(x));
}
char Dfeq[] = "exp(x)";
/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */

/* --------------------------------- MAIN ----------------------------------- */
int main(void)
{
double (*Pfunct)     (double x);
double (*PfunctDeriv)(double x);

double c = .5;
double t;
/*-------------------------------- PROGRAM ---------------------------------- */
 Pfunct      =  f;
 PfunctDeriv = Df;

 clrscrn();
 printf("  f : x-> %s\n\n", feq);
 printf(" Df : x-> %s\n\n",Dfeq);

 printf(" With c = %0.3lf, the equation of the tangent is :\n\n",c);
 printf("       Df(c) (x-c) + f(c) = ");
 eq_Tan(  c,
       (*Pfunct),
       (*PfunctDeriv)
       );
 printf("\n\n\n\n");
 getchar();


 clrscrn();
 printf(" Find PA, the length of the tangent from P to the x axis.\n\n");

 t = ((*Pfunct)(c));
 printf(" P(%6.3lf, %6.3lf)         -> P(c, f(c))       \n", c, t);

 t = c- ( ((*Pfunct)(c)) / ((*PfunctDeriv)(c)) );
 printf(" A(%6.3lf, %6.3lf)         -> A(c-f(c)/Df(c),0)\n\n",t, 0.0);

 t = ((*Pfunct)(c)) * sqrt(1+(1/ pow(((*PfunctDeriv)(c)) ,2)   ));
 printf(" PA = %6.3lf               -> f(c) sqrt(1+(1/Df(c)**2))", t);
                        
                         /* plot [xmin:xmax] [ymin:ymax] */
 gplt_TanPx    (-4,      /* xmin  */
                 4,      /* xmax  */
                -4,      /* ymin  */
                 4,      /* ymax  */
                 c,
               feq,
         (*Pfunct),
         (*PfunctDeriv));

 printf("\n\n To see the result in Gnuplot (gp373w32.exe) :\n\n");
 printf("     * open the file f_Df.plt with Gnuplot.\n");

 printf("\n Press return to continue");
 getchar();

 return 0;
}

